/*

 
  CopperC.c                                                   
 
  Usando retrazos horizontales y verticales cambiamos las componentes de la
  paleta del color de fondo (0) para simular franjas horizontales que si
  son colocadas en forma de gradientes simulan una barra grfica en modo 
  texto de 80x25.                                              
 
  1996, [NoP]/Compiler SoftWare
 
*/

#include <stdio.h>                      // kbhit();
#include <conio.h>                      // kbhit();
#include <dos.h>                        // para las func. de puertos

#define ARRIBA 0                        // direccin de la barra
#define ABAJO  1

int f;
char direccion = ABAJO;
int linea_actual = 2;

/* funcin principal */

void main(void)
{

 printf("Copperc.exe:\r\n");
 printf("Mediante ALT+ENTER, es recomendable probar el programa bajo Windows\r\n");
 printf("entre pantalla completa y ventana de texto, apreciando que en este\r\n");
 printf("ltimo caso el efecto no aparece (las ventanas son emulaciones de la\r\n");
 printf("VRAM de texto dentro del modo grfico.\r\n\n");
 printf("La lentitud que se aprecia bajo Windows es debida a esos fallos de\r\n");
 printf("'timing' comentados en la revista.\r\n\n");

while( !kbhit() )
{

    while ((inportb( 0x3DA ) & 8) > 0 )    ;
    while ((inportb( 0x3DA ) & 8) == 0)    ;//esperamos retrazo vertical
    
    for ( f=0; f< linea_actual  ;f++)       //esperamos retrazos horiz. hasta
    {                                       //que estemos en la 1 lnea de
                                            //la barra
      while ((inportb(0x3DA) & 1) == 0)    ;
      while ((inportb(0x3DA) & 1) > 0)     ;
    }

    for (f=0 ; f<63 ; f++)                  //63 lneas de negro a verde
    {
      while ((inportb(0x3DA) & 1) > 0)     ;
      outportb(0x3C8, 0);
      outportb(0x3C9, 0);
      outportb(0x3C9, f);
      outportb(0x3C9, 0);                 // SetPal( 0, 0, f, 0 );
      while ((inportb(0x3DA) & 1) == 0)    ;
    }

    for (f=63 ; f>0; f--)                   //63 lneas de verde a negro
    {
      while ((inportb(0x3DA) & 1) > 0)     ;
      outportb(0x3C8, 0);
      outportb(0x3C9, 0);
      outportb(0x3C9, f);
      outportb(0x3C9, 0);                 // SetPal( 0, 0, f, 0 );
                       
      while ((inportb(0x3DA) & 1) == 0)    ;
    }
                                            //cambios de direcciones y actua-
                                            //lizacin de variables.

    if( linea_actual == 1 && direccion == ARRIBA ) direccion = ABAJO;
    else if( linea_actual > 145 && direccion == ABAJO ) direccion = ARRIBA;

    if( direccion == ABAJO ) linea_actual++;
    else linea_actual--;
  };

 //restauramos el color de fondo
      outportb(0x3C8, 0);
      outportb(0x3C9, 0);
      outportb(0x3C9, 0);
      outportb(0x3C9, 0);
 
}
