/*                                                                          
  Ŀ
   Ejemplo1.c                                                             
                                                                          
   Cambio de la paleta actual mediante modificacin de los registros.     
                                                                          
   Compilado con :  Borland C/C++ v3.1                                    
   Cdigo y texto:  [NoP] de Compiler SoftWare.                     
  1997 C.S.
*/

#include <stdio.h>               /* funciones estndar Input/Output */
#include <dos.h>                 /* funciones outportx(); e inportx() */
#include "reglib\vgaregs.h"         /* librera funciones registros */
#include "vgalibs\ints.h"           /* librera funciones varias int 10h */

/*  Funcin principal main()  */

void main( void )
{

 SetVideoMode(3);                        /* inicializar 80x25x16 (3h) */

 printf("EJEMPLO2.EXE\r\n");
 printf("Cambio de un color de la paleta mediante registros VGA.\r\n");
 printf("Se cambia las componentes RGB del color 7 a (60,60,0) (amarillo).\r\n\n");

 printf("      3C8h (R/W): PEL Address Write Mode        (VGA Only)\r\n");
 printf("      bit 0-7  The PEL data register (0..255) to be written to 3C9h.\r\n");
 printf("      Note:  After writing the 3 bytes at 3C9h this register will\r\n");
 printf("             increment, pointing to the next data register.\r\n\n");

 printf("      3C9h (R/W): PEL Data Register             (VGA Only)\r\n");
 printf("      bit 0-5  Color value\r\n");
 printf("      Note:  Each read or write of this register will cycle through first\r\n");
 printf("             the registers for Red, Blue and Green, then increment the\r\n"); 
 printf("             appropriate address register, thus the entire palette can be\r\n");
 printf("             loaded by writing 0 to the PEL Address Write Mode register 3C8h\r\n");
 printf("             and then writing all 768 bytes of the palette to this register.\r\n\n");

 printf(" Sentencias:    writeVGAREG( 0x3c8, 0, 7 );\r\n");
 printf("                writeVGAREG( 0x3c9, 0, 60 );\r\n");
 printf("                writeVGAREG( 0x3c9, 0, 60 );\r\n");
 printf("                writeVGAREG( 0x3c9, 0, 0 );\r\n\n");
 
 WriteVGAREG( 0x3c8, 0, 7 );
 WriteVGAREG( 0x3c9, 0, 60 );
 WriteVGAREG( 0x3c9, 0, 60 );
 WriteVGAREG( 0x3c9, 0, 0 );

}
